<template>
  <v-data-table
    :headers="headers"
    :loading="loading"
    :items="loads"
    :page="page+1"
    :items-per-page="pageSize"
    :server-items-length="total"
    class="elevation-1"
    @click:row="goToDetails"
  >
    <template #top>
      <v-row no-gutters justify="end">
        <v-col cols="3">
          <v-select
            v-model="stateSelected"
            label="Filtrado por estado"
            :items="LoadStatus"
            class="mx-2"
          />
        </v-col>
      </v-row>
    </template>
    <template #item.id="{ item }">
      {{ hashId(item) }}
    </template>
    <template #item.responsible="{ item }">
      {{ `${item.responsible.names} ${item.responsible.lastnames}` }}
    </template>
    <template #item.loadedAt="{ item }">
      {{ toLocalDate(item.loadedAt) }}
    </template>
  </v-data-table>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { errorOptions } from '~/helpers/toast';
import { hashId } from '~/helpers/format/ids';
import { toLocalDate } from '~/helpers/format/time';
import LoadStatus, { ALL } from '~/services/sync/load-status';

export default {
  name: 'LoadsTable',
  data: () => ({
    LoadStatus,
    loading: false,
    stateSelected: ALL,
    search: '',
    headers: [
      { text: 'Nª', align: 'start', sortable: false, value: 'id' },
      { text: 'Tipo de dato', sortable: false, value: 'dataType' },
      { text: 'Fecha de carga', sortable: false, value: 'loadedAt' },
      { text: 'Responsable', sortable: false, value: 'responsible' },
      { text: 'Estado', sortable: false, value: 'state' },
    ],
  }),
  computed: {
    ...mapState({
      loads: state => state.sync.loads.loads,
      page: state => state.sync.loads.pageInfo.page,
      pageSize: state => state.sync.loads.pageInfo.pageSize,
      total: state => state.sync.loads.pageInfo.total,
    }),
  },
  watch: {
    stateSelected() {
      this.getLoadsData();
    },
  },
  async mounted() {
    await this.getLoadsData();
  },
  methods: {
    ...mapActions({
      getLoads: 'sync/loads/getLoads',
    }),
    hashId,
    toLocalDate,
    async getLoadsData() {
      this.loading = true;
      try {
        await this.getLoads({ state: this.stateSelected });
      } catch (e) {
        this.$toast.error('No se pudo obtener las cargas de datos', errorOptions);
      }
      this.loading = false;
    },
    async goToDetails({ id }) {
      await this.$router.push(`/sincronizacion/cargas/${id}`);
    },
  },
};
</script>
